Attribute VB_Name = "ModIcoEd"
Option Explicit



Type BITMAPINFOHEADER
     biSize As Long
     biWidth As Long
     biHeight As Long
     biPlanes As Integer
     biBitCount As Integer
     biCompression As Long
     biSizeImage As Long
     biXPelsPerMeter As Long
     biYPelsPerMeter As Long
     biClrUsed As Long
     biClrImportant As Long
End Type

Type ICONDIR
     idReserved As Integer
     idType As Integer
     idCount As Integer
End Type

Type ICONDIRENTRY
     bWidth As Byte
     bHeight As Byte
     bColorCount As Byte
     bReserved As Byte
     wPlanes As Integer
     wBitCount As Integer
     dwBytesInRes As Long
     dwImageOffset As Long
End Type

Type RECT
     Left As Long
     Top As Long
     Right As Long
     Bottom As Long
End Type

Global CancelIt As Boolean
Global BitCnt As Long
Public ID As ICONDIR
Public BIH32 As BITMAPINFOHEADER
Public IDE32 As ICONDIRENTRY
Public BIH16 As BITMAPINFOHEADER
Public IDE16 As ICONDIRENTRY
Public ID16 As ICONDIR
Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Declare Function ExtractIconEx Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile As String, ByVal nIconIndex As Long, phiconLarge As Long, phiconSmall As Long, ByVal nIcons As Long) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long) As Long
Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal x1 As Long, ByVal y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Public TransCol
Public Dirty As Boolean
Public Const Ttl = "createAppIcon"
Public Sub CheckSettings()
Dim Ret1
    #If Win32 Then
        If Not ScreenDimensionsOk Then End
        If Not ColorModeOk Then End
        'Ret1 = MsgBox("Unless your color settings are changed to 24bit or higher, Icons produced by this program are not viewed properly (Icons will have Gray where transparency should be). Do you want to continue?", vbYesNo, "Improper Settings")
        'If Ret1 = vbNo Then End
        'End If
        Form1.Show
    #Else
        End
    #End If
End Sub
Private Function ScreenDimensionsOk() As Boolean
    Dim Msg As String
    Dim ScreenHeight As Integer
    Dim ScreenWidth As Integer

    ScreenDimensionsOk = True

    ScreenWidth = GetSystemMetrics(0)
    ScreenHeight = GetSystemMetrics(1)

    If ScreenHeight < 480 Or ScreenWidth < 640 Then
       Msg = Ttl & " requires a screen resolution of at least 640 x 480 pixels."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & "Please adjust your screen resolution and try again."
       MsgBox Msg, vbCritical, Ttl & " - Error"
       ScreenDimensionsOk = False
    End If

End Function
Private Function ColorModeOk() As Boolean

    Dim Msg As String
    Dim hScreenDc As Long

    hScreenDc = GetDC(0)
    
    If GetDeviceCaps(hScreenDc, 12) > 8 Then
       ColorModeOk = True
    Else
       Msg = Ttl & " requires at least high color mode."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & "Please adjust your color mode and try again."
       MsgBox Msg, vbCritical, Ttl & " - Error"
    End If

End Function


Public Sub PrepIconHeader()
'Icon Format
'ID
'IDE32
'IDE16
'IDE32.dwBytesInRes
'IDE16.dwBytesInRes
    ID.idReserved = 0
    ID.idType = 1
    ID.idCount = 2
'MsgBox "Len(ID): " & Len(ID)
    ID16.idReserved = 0
    ID16.idType = 1
    ID16.idCount = 1
    
    IDE32.bWidth = 32
    IDE32.bHeight = 32
    IDE32.bColorCount = 0
    IDE32.bReserved = 0
    IDE32.wPlanes = 1
    IDE32.wBitCount = 24
    IDE32.dwBytesInRes = 3240
    IDE32.dwImageOffset = Len(ID) + Len(IDE32) + Len(IDE16)
'MsgBox "Len(IDE32): " & Len(IDE32)
    IDE16.bWidth = 16
    IDE16.bHeight = 16
    IDE16.bColorCount = 0
    IDE16.bReserved = 0
    IDE16.wPlanes = 1
    IDE16.wBitCount = 24
    IDE16.dwBytesInRes = 872
    IDE16.dwImageOffset = Len(ID) + Len(IDE32) + Len(IDE16) + IDE32.dwBytesInRes
    
    BIH32.biSize = 40
    BIH32.biWidth = 32
    BIH32.biHeight = 64
    BIH32.biPlanes = 1
    BIH32.biBitCount = 24
    BIH32.biCompression = 0
    BIH32.biSizeImage = 3200
    BIH32.biXPelsPerMeter = 0
    BIH32.biYPelsPerMeter = 0
    BIH32.biClrUsed = 0
    BIH32.biClrImportant = 0
    
    BIH16.biSize = 40
    BIH16.biWidth = 16
    BIH16.biHeight = 32
    BIH16.biPlanes = 1
    BIH16.biBitCount = 24
    BIH16.biCompression = 0
    BIH16.biSizeImage = 832
    BIH16.biXPelsPerMeter = 0
    BIH16.biYPelsPerMeter = 0
    BIH16.biClrUsed = 0
    BIH32.biClrImportant = 0
End Sub
